/**
 * This is a generated class and is not intended for modification.  To customize behavior
 * of this value object you may modify the generated sub-class of this class - NoName1.as.
 */

package valueObjects
{
import com.adobe.fiber.services.IFiberManagingService;
import com.adobe.fiber.util.FiberUtils;
import com.adobe.fiber.valueobjects.IValueObject;
import flash.events.Event;
import flash.events.EventDispatcher;
import mx.binding.utils.ChangeWatcher;
import mx.collections.ArrayCollection;
import mx.events.PropertyChangeEvent;
import mx.validators.ValidationResult;
import valueObjects.Table;

import flash.net.registerClassAlias;
import flash.net.getClassByAlias;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;

use namespace model_internal;

[ExcludeClass]
public class _Super_NoName1 extends flash.events.EventDispatcher implements com.adobe.fiber.valueobjects.IValueObject
{
    model_internal static function initRemoteClassAliasSingle(cz:Class) : void
    {
    }

    model_internal static function initRemoteClassAliasAllRelated() : void
    {
        valueObjects.Table.initRemoteClassAliasSingleChild();
        valueObjects.Definition.initRemoteClassAliasSingleChild();
        valueObjects.Rows.initRemoteClassAliasSingleChild();
    }

    model_internal var _dminternal_model : _NoName1EntityMetadata;
    model_internal var _changedObjects:mx.collections.ArrayCollection = new ArrayCollection();

    public function getChangedObjects() : Array
    {
        _changedObjects.addItemAt(this,0);
        return _changedObjects.source;
    }

    public function clearChangedObjects() : void
    {
        _changedObjects.removeAll();
    }

    /**
     * properties
     */
    private var _internal_lastStoreTime : String;
    private var _internal_table : valueObjects.Table;

    private static var emptyArray:Array = new Array();


    /**
     * derived property cache initialization
     */
    model_internal var _cacheInitialized_isValid:Boolean = false;

    model_internal var _changeWatcherArray:Array = new Array();

    public function _Super_NoName1()
    {
        _model = new _NoName1EntityMetadata(this);

        // Bind to own data or source properties for cache invalidation triggering
        model_internal::_changeWatcherArray.push(mx.binding.utils.ChangeWatcher.watch(this, "lastStoreTime", model_internal::setterListenerLastStoreTime));
        model_internal::_changeWatcherArray.push(mx.binding.utils.ChangeWatcher.watch(this, "table", model_internal::setterListenerTable));

    }

    /**
     * data/source property getters
     */

    [Bindable(event="propertyChange")]
    public function get lastStoreTime() : String
    {
        return _internal_lastStoreTime;
    }

    [Bindable(event="propertyChange")]
    public function get table() : valueObjects.Table
    {
        return _internal_table;
    }

    public function clearAssociations() : void
    {
    }

    /**
     * data/source property setters
     */

    public function set lastStoreTime(value:String) : void
    {
        var oldValue:String = _internal_lastStoreTime;
        if (oldValue !== value)
        {
            _internal_lastStoreTime = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "lastStoreTime", oldValue, _internal_lastStoreTime));
        }
    }

    public function set table(value:valueObjects.Table) : void
    {
        var oldValue:valueObjects.Table = _internal_table;
        if (oldValue !== value)
        {
            _internal_table = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "table", oldValue, _internal_table));
        }
    }

    /**
     * Data/source property setter listeners
     *
     * Each data property whose value affects other properties or the validity of the entity
     * needs to invalidate all previously calculated artifacts. These include:
     *  - any derived properties or constraints that reference the given data property.
     *  - any availability guards (variant expressions) that reference the given data property.
     *  - any style validations, message tokens or guards that reference the given data property.
     *  - the validity of the property (and the containing entity) if the given data property has a length restriction.
     *  - the validity of the property (and the containing entity) if the given data property is required.
     */

    model_internal function setterListenerLastStoreTime(value:flash.events.Event):void
    {
        _model.invalidateDependentOnLastStoreTime();
    }

    model_internal function setterListenerTable(value:flash.events.Event):void
    {
        _model.invalidateDependentOnTable();
    }


    /**
     * valid related derived properties
     */
    model_internal var _isValid : Boolean;
    model_internal var _invalidConstraints:Array = new Array();
    model_internal var _validationFailureMessages:Array = new Array();

    /**
     * derived property calculators
     */

    /**
     * isValid calculator
     */
    model_internal function calculateIsValid():Boolean
    {
        var violatedConsts:Array = new Array();
        var validationFailureMessages:Array = new Array();

        var propertyValidity:Boolean = true;
        if (!_model.lastStoreTimeIsValid)
        {
            propertyValidity = false;
            com.adobe.fiber.util.FiberUtils.arrayAdd(validationFailureMessages, _model.model_internal::_lastStoreTimeValidationFailureMessages);
        }
        if (!_model.tableIsValid)
        {
            propertyValidity = false;
            com.adobe.fiber.util.FiberUtils.arrayAdd(validationFailureMessages, _model.model_internal::_tableValidationFailureMessages);
        }

        model_internal::_cacheInitialized_isValid = true;
        model_internal::invalidConstraints_der = violatedConsts;
        model_internal::validationFailureMessages_der = validationFailureMessages;
        return violatedConsts.length == 0 && propertyValidity;
    }

    /**
     * derived property setters
     */

    model_internal function set isValid_der(value:Boolean) : void
    {
        var oldValue:Boolean = model_internal::_isValid;
        if (oldValue !== value)
        {
            model_internal::_isValid = value;
            _model.model_internal::fireChangeEvent("isValid", oldValue, model_internal::_isValid);
        }
    }

    /**
     * derived property getters
     */

    [Transient]
    [Bindable(event="propertyChange")]
    public function get _model() : _NoName1EntityMetadata
    {
        return model_internal::_dminternal_model;
    }

    public function set _model(value : _NoName1EntityMetadata) : void
    {
        var oldValue : _NoName1EntityMetadata = model_internal::_dminternal_model;
        if (oldValue !== value)
        {
            model_internal::_dminternal_model = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_model", oldValue, model_internal::_dminternal_model));
        }
    }

    /**
     * methods
     */


    /**
     *  services
     */
    private var _managingService:com.adobe.fiber.services.IFiberManagingService;

    public function set managingService(managingService:com.adobe.fiber.services.IFiberManagingService):void
    {
        _managingService = managingService;
    }

    model_internal function set invalidConstraints_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_invalidConstraints;
        // avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_invalidConstraints = value;
            _model.model_internal::fireChangeEvent("invalidConstraints", oldValue, model_internal::_invalidConstraints);
        }
    }

    model_internal function set validationFailureMessages_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_validationFailureMessages;
        // avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_validationFailureMessages = value;
            _model.model_internal::fireChangeEvent("validationFailureMessages", oldValue, model_internal::_validationFailureMessages);
        }
    }

    model_internal var _doValidationCacheOfLastStoreTime : Array = null;
    model_internal var _doValidationLastValOfLastStoreTime : String;

    model_internal function _doValidationForLastStoreTime(valueIn:Object):Array
    {
        var value : String = valueIn as String;

        if (model_internal::_doValidationCacheOfLastStoreTime != null && model_internal::_doValidationLastValOfLastStoreTime == value)
           return model_internal::_doValidationCacheOfLastStoreTime ;

        _model.model_internal::_lastStoreTimeIsValidCacheInitialized = true;
        var validationFailures:Array = new Array();
        var errorMessage:String;
        var failure:Boolean;

        var valRes:ValidationResult;
        if (_model.isLastStoreTimeAvailable && _internal_lastStoreTime == null)
        {
            validationFailures.push(new ValidationResult(true, "", "", "lastStoreTime is required"));
        }

        model_internal::_doValidationCacheOfLastStoreTime = validationFailures;
        model_internal::_doValidationLastValOfLastStoreTime = value;

        return validationFailures;
    }
    
    model_internal var _doValidationCacheOfTable : Array = null;
    model_internal var _doValidationLastValOfTable : valueObjects.Table;

    model_internal function _doValidationForTable(valueIn:Object):Array
    {
        var value : valueObjects.Table = valueIn as valueObjects.Table;

        if (model_internal::_doValidationCacheOfTable != null && model_internal::_doValidationLastValOfTable == value)
           return model_internal::_doValidationCacheOfTable ;

        _model.model_internal::_tableIsValidCacheInitialized = true;
        var validationFailures:Array = new Array();
        var errorMessage:String;
        var failure:Boolean;

        var valRes:ValidationResult;
        if (_model.isTableAvailable && _internal_table == null)
        {
            validationFailures.push(new ValidationResult(true, "", "", "table is required"));
        }

        model_internal::_doValidationCacheOfTable = validationFailures;
        model_internal::_doValidationLastValOfTable = value;

        return validationFailures;
    }
    

}

}
